(HDU 3853) LOOPS (概率DP)

Problem Description
Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl).

Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS.

The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)!
At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS.




 

 

Input
The first line contains two integers R and C (2 <= R, C <= 1000).

The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces.

It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them).

You may ignore the last three numbers of the input data. They are printed just for looking neat.

The answer is ensured no greater than 1000000.

Terminal at EOF


 

 

Output
A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS.

 

 

Sample Input
2 2 0.00 0.50 0.50 0.50 0.00 0.50 0.50 0.50 0.00 1.00 0.00 0.00
 

 

Sample Output
6.000
 

 

Source

 和POJ 2096的解法差不多(我的另外一篇博客),但是比那道题更容易理解,模型要更明显;

题目已经明确的说三个概率加起来一定等于1,所以很显然的得出概率的推导式,dp[i][j]可以转化成dp[i][j],dp[i+1][j]以及dp[i][j+1]。

转移方程就能够写出:dp[i][j]=p1*dp[i][j]+p2*dp[i][j+1]+p3*dp[i+1][j]+2;

初始状态为dp[r][s]=0;

倒推求出dp[1][1]就是最后的答案;

注意:转移到自己的概率为1的情况要特殊注意,此时不能逃出迷宫!

 

#include<iostream>
#include<cstdio>
#include<vector>
#include<set>
#include<map>
#include<string.h>
#include<cmath>
#include<algorithm>
#include<queue>
#include<stack>
#define LL long long
#define mod 1000000007
#define inf 0x3f3f3f3f

using namespace std;

double a[1010][1010][4];
double dp[1010][1010];

int main()
{
    int r,s;
    while(~scanf("%d%d",&r,&s))
    {
        memset(dp,0,sizeof(dp));
        memset(a,0,sizeof(a));
        for(int i=1;i<=r;i++)
            for(int j=1;j<=s;j++)
            {
                double p1,p2,p3;
                scanf("%lf%lf%lf",&p1,&p2,&p3);
                a[i][j][1]=p1;
                a[i][j][2]=p2;
                a[i][j][3]=p3;

            }
            for(int i=r;i>=1;i--)
                for(int j=s;j>=1;j--)
                {
                    if(i==r&&j==s)
                        continue;
                        if(a[i][j][1]==1.0)
                            continue;
                    dp[i][j]=(a[i][j][2]*dp[i][j+1]+a[i][j][3]*dp[i+1][j]+2)/(1-a[i][j][1]);
                }
                printf("%.3lf\n",dp[1][1]);
    }
    return 0;
}

 

转载于:https://www.cnblogs.com/brotherHaiNo1/p/8431461.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值